<!doctype html>
<html>

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

	<title>Pseudocode</title>

	<link rel="icon" type="image/png" href="images/org_symbol.png" />
	<link rel="stylesheet" href="css/reset.css">
	<link rel="stylesheet" href="css/reveal.css">

	<link rel="stylesheet" href="css/theme/black.css" id="theme">

	<!-- Theme used for syntax highlighting of code -->
	<link rel="stylesheet" href="lib/css/monokai.css">

	<!-- Printing and PDF exports -->
	<script>
		var link = document.createElement('link');
		link.rel = 'stylesheet';
		link.type = 'text/css';
		link.href = window.location.search.match(/print-pdf/gi) ? 'css/print/pdf.css' : 'css/print/paper.css';
		document.getElementsByTagName('head')[0].appendChild(link);
	</script>
</head>

<body>
	<!-- UGLY inline CSS but using this div to test Unclassified banner -->
	<!-- <div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div> -->
	<div class="reveal">
		<div class="slides">
            <section data-background-image="images/org_symbol.png" data-background-size="8%"data-background-position="top 5% left 5%">
                <section>
                    <h1>Logic & Design</h1>
                </section>
                <section >
                    <h2>Overview</h2>
                    <ul>
                        <li><em>Pseudocode Examples</em></li>
                        <li>
                            Logical Structures
                            <ul>
                                <li>Conditional Statements</li>
                                <li>Loops</li>
                                <li>Arrays</li>
                                <li>Exception Handling</li>
                            </ul>
                        </li>
                    </ul>
                    <aside class="notes">
                        Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
                        instructor view!!
                    </aside>
                </section>
                <section>
                    <h2>Course Objectives</h2>
                </section>
            </section>
            <section>
                <section>
                    <h3>Example Programming structures</h3>

					<img height=400; style="outline:none; border-style: none" src="../../assets/03_strua.png"
						alt="Example program structures">

					<p><a href="https://docs.oracle.com/cd/A87860_01/doc/appdev.817/a77069/03_struc.htm">Example
							structures from Oracle</a></p>
                </section>
                <section>
                    <h3>Understanding Three Basic Structures</h3>
                    
                    <ul>
                        <li>Sequence structure
                            <ul>
                                <li>Perform actions or tasks in order</li>
                                <li>No branching or skipping any task</li>
                            </ul>
                        </li>
                        <li>Selection structure (decision structure)
                            <ul>
                                <li>Evaluate a Boolean expression, a statement that is either true or false</li>
                                <li>Often called if-then-else</li>
                            </ul>
                        </li>
                        <li>Loop structure
                            <ul>
                                <li>Repeat actions while a condition remains true</li>
                            </ul>
                        </li>
                    </ul>
                </section>
                <section>
                    <h3>Pseudocode for a Guessing Game</h3>

					<pre style="left: 0;">
                        <b>START:</b>					
                        <b>SET</b> the secret number
                        <b>GET</b> user guess
                        <b>WHILE</b> user guess not equal to secret number:
                            <b>IF</b> the user guess is too high, 
                            tell the user it is too high
                            <b>ELSE IF</b> the user guess it too low, 
                                    tell the user it is too low
                            <b>GET </b>user guess
                        Tell user that she guessed the correct number
                        <b>STOP</b>
                    </pre>
                </section>
            </section>
            <section>
                <section>
                    <h2>Selection Structure (Making Decisions)</h2>
                    <p>allows one set of statements to be executed if a condition is true and another set of actions to be executed if a condition is false</p>
                </section>
                <section>
                    <h3>If-Then-Else structure</h3>
                    <ul>
                        <li>Evaluate a Boolean Expression (True/False)
                            <ul>
                                <li>AND operator (&&)</li>
                                <li>OR operator (||)</li>
                                <li>NOT operator (!)</li>
                            </ul>
                        </li>
                        <li>Evaluate Comparison Operator
                            <ul>
                                <li>(< , >, <=, etc.)</li>
                            </ul>
                        </li>
                    </ul>
                </section>
                <section>
					<h3>Pseudocode for example for Assigning Grades</h3>
					<pre>
                        <b>START:</b>
                        <b>INPUT</b>  enter grade
                        <b>IF</b> grade > 69:
                            <b>RETURN</b> "C" 
                        <b>ELSE IF</b> grade > 79:
                            <b>RETURN</b> "B" 
                        <b>ELSE IF </b>grade > 89:
                            <b>RETURN</b> "A"
                        <b>ELSE</b>:
                            <b>RETURN</b> "F"
                        <b>STOP</b>
					</pre>
					<h3>Why could this be <b style="color:crimson">BAD</b>?</h3>
				</section>

				<section>
					<h3>Pseudocode to Assign Grades</h3>
					<pre>
                        <b>START</b>:
                        <b>INPUT</b> enter grade
                        <b>IF</b> grade > 89:
                            <b>RETURN</b> "A"
                        <b>ELSE IF</b> grade > 79:
                            <b>RETURN</b> "B"
                        <b>ELSE IF</b> grade > 69:
                            <b>RETURN</b> "C"
                        <b>ELSE</b>:
                            <b>RETURN</b> "F"
                        <b>STOP</b>
					</pre>
				</section>
				<section>
					<h3>Compare the Two Algorithms</h3>
					<table>
						<tr>
							<td><img height=360; src="../../assets/bad_grades.png" alt="A bad way to determine grades">
							</td>
							<td><img height=360; src="../../assets/good_grades.png" alt="A better way to determine grades">
							</td>
						</tr>
					</table>
					<p>Sketch out an example flow chart to consider why the first example fails</p>
				</section>

				<section>
					<h3>This also works**</h3>
					<pre>
                        <b>START</b>:
                        <b>INPUT</b> enter grade
                        <b>IF</b> grade < 70:
                            <b>RETURN</b> "F" 
                        <b>ELSE IF</b> grade < 80: 
                            <b>RETURN</b> "C"
                        <b>ELSE IF</b> grade < 90: 
                            <b>RETURN</b> "B"
                        <b>ELSE</b>:
                            <b>RETURN</b> "A"
                        <b>STOP</b>
					</pre>
                    <p><i>However, </i>what happens if the teacher enters a grade of "<i style="color:crimson">PUPPY</i>"?</p>
                </section>
            </section>
            <section>
                <section>
                    <h2>Looping</h2>
                    <p>In computer science, a loop is a programming structure that repeats a sequence of instructions until a specific condition is met.</p>
                </section>
                <section>
                    <h3>Loops</h3>
                    <h4>I.E. Iteration</h4>
                    <img height=400; style="outline:none; border-style: none" src="../../assets/pictionary_flowchart.png"
						alt="How to Play Pictionary">

					<p style='font-size:30%'' ><a href="http://www.thedoghousediaries.com/2659">From Dog House Diaries</a></p>
                </section>
                <section>
                    <h3>Types of Loops</h3>
                    <ul>
                        <li>While
                            <ul>
                                <li>The simplest form of a programming loop.</li>
                                <li>It states that while a condition is valid, keep looping.</li>
                            </ul>
                        </li>
                        <li>For
                            <ul>
                                <li>Cleaner and Easier to use</li>
                                <li>Defines a Start and End point</li>
                                <li>Iterates through each increment for the Loop</li>
                            </ul>
                        </li>
                    </ul>
                </section>
                <section>
                    <h3>While Loops</h3>

                    <pre style="left: 0;">
                        <b>START:</b>					
                        <b>SET</b> count = 0
                        <b>WHILE</b> count <= 3
                            <b>OUTPUT</b> "hello"
                            <b>SET</b> count = count + 1
                        <b>ENDWHILE</b>
                        <b>STOP</b>
                    </pre>
                </section>
                <section>
                    <h3>For Loops</h3>

                    <pre style="left: 0;">
                        <b>START:</b>					
                        <b>FOR</b> count = 0 to 3 step 1                           
                            <b>OUTPUT</b> "hello"
                        <b>ENDFOR</b>
                        <b>STOP</b>
                    </pre>
                </section>
            </section>
            <section>
                <section>
                    <h2>Labs</h2>
                </section>
            </section>
            <section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">
				<section>
                    <h2>Using Arrays and Functions</h2>    
				</section>
				<section>
					<h3>Using an Array </h3>
					<img src="../../assets/arrayflowchart.png" alt="Using an array">
				</section>
				<section>
					<h4> Pass by Value </h4>
					<img height=500; src="../../assets/passbyvalue.png" alt="Pass by value">
				</section>
				<section>
					<h4>Pass by reference </h4>
					<img height=600; src="../../assets/passbyref.png" alt="Pass by reference">
				</section>
				<section>
					<h3>Function Example</h3>
					<pre>
                        <b>START</b>:
                        <b>SUBROUTINE</b> getAverageofThree(a, b, c)
                            total <-- a + b + c
                            avg = total/3
                            RETURN avg
                        <b>END SUBROUTINE</b>

                        <b>OUTPUT</b> "Enter 3 grades"
                        grade1 <-- <b>USERINPUT</b>
                        grade2 <-- <b>USERINPUT</b>
                        grade3 <-- <b>USERINPUT</b>
                        average <-- getAverageofThree(grade1, grade2, grade3)
                        <b>OUTPUT</b> "Total points were " + total
                        <b>OUTPUT</b> "The grade is " + avg

                        <b>STOP</b>
			        </pre>
					<p>Look also <a
							href="https://bournetocode.com/projects/GCSE_Computing_Fundamentals/pages/3-2-7-subroutines.html">
							here </a> </p>
				</section>
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">
				<section>
					<h2>Exception handling explanation flowcharts</h2>
					<ul>
						<li>Naive password model</li>
						<li>How exploits happen</li>
						<li>How we stop simple exploits</li>
					</ul>
				</section>
				<section>
					<h3>Simple Password </h3>
					<img height=500; src="../../assets/simplepassword.png" alt="Simple Password Flowchart">
				</section>
				<section>
					<h3>Simple Password Exploit</h3>
					<img height=500; src="../../assets/exploit_password.png" alt="Simple Password Exploit Flowchart">
				</section>
				<section>
					<h3 style='font-size:80%'>Simple Password Exception Handled</h3>
					<img height=600; src="../../assets/exceptionhandled_passwd.png" alt="Simple Password Flowchart">
                </section>
            </section>
            <section>
                <section>
                    <h2>Labs</h2>
                </section>
            </section>
            <section>
                <section>
                    <h2>Overview</h2>
                    <ul>
                        <li><em>Pseudocode Examples</em></li>
                        <li>
                            Logical Structures
                            <ul>
                                <li>Conditional Statements</li>
                                <li>Loops</li>
                                <li>Arrays</li>
                                <li>Exception Handling</li>
                            </ul>
                        </li>
                    </ul>
                </section>
                <section>
                    <h2>Questions</h2>
                </section>
            </section>
        </div>
	</div>
	<!-- This footer doesn't work. Need to play with CSS -->
	<!-- <footer style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer> -->

	<!-- DO NOT TOUCH -->
	<script src="js/reveal.js"></script>

	<script>
		Reveal.initialize({
			slideNumber: true,
			hash: true,
			menu: {
				side: 'left',
				width: 'normal',
				numbers: true,
				titleSelector: 'h1, h2, h3, h4, h5, h6',
				useTextContentForMissingTitles: false,
				hideMissingTitles: false,
				markers: true,
				custom: false,
				themes: true,
				themesPath: 'css/theme/',
				transitions: true,
				openButton: true,
				openSlideNumber: true,
				keyboard: true,
				sticky: true,
				autoOpen: true,
				delayInit: false,
				openOnInit: false,
				loadIcons: true
			},
			dependencies: [
				{ src: 'plugin/markdown/marked.js' },
				{ src: 'plugin/markdown/markdown.js' },
				{ src: 'plugin/highlight/highlight.js' },
				{ src: 'plugin/notes/notes.js', async: true },
				{ src: 'plugin/reveal.js-menu/menu.js' }
			]
		});
		Reveal.configure({ slideNumber: true })
	</script>
</body>

</html>
